using namespace SmartWin;

class FensterFabrik  : public WidgetFactory<WidgetWindow, FensterFabrik>
{  
 public:    
	// Threads hinzufgen
	Utilities::Thread rs232Thread;
	Utilities::Thread exitThread;
    //fr Thread:
	bool isClosing;

	// Constructor only initializing isClosing to true, no other purpose...
	FensterFabrik() : isClosing( false )
	{}

  void init()
  {                            
	createWindow();
	
	onClosing( &FensterFabrik::closeApp );

	onPainting( &FensterFabrik::painting );
	
	setIconSmall("fbt.ico");
	setBounds(10,10,FENSTERBREITE,FENSTERHOEHE);
	setText("AVR Kommunikation via RS232");	

    WidgetStatic* labelA = createStatic();
    labelA->setBounds(10,6,100,KNOPFHOEHE);
    labelA->setText("SENDEN");

    WidgetStatic* labelB = createStatic();
    labelB->setBounds(10,6+FENSTERHOEHE/2+KNOPFHOEHE-40-180,100,KNOPFHOEHE);
    labelB->setText("EMPFANGEN");

    textboxA = createTextBox();         
//    textboxA->setBounds(10,30+KNOPFHOEHE+2,FENSTERBREITE/2-30,FENSTERHOEHE/2-80);
    textboxA->setBounds(10,30+KNOPFHOEHE+2,370,FENSTERHOEHE/2-80-180);
    textboxA->setScrollBarVertically(true);
	    
    textboxB = createTextBox();         
//    textboxB->setBounds(10,30+FENSTERHOEHE/2+KNOPFHOEHE+2+KNOPFHOEHE+2-40,FENSTERBREITE/2-30,FENSTERHOEHE/2-80);
    textboxB->setBounds(10,30+FENSTERHOEHE/2+KNOPFHOEHE+2+KNOPFHOEHE+2-40-180,370,FENSTERHOEHE/2-80+180);
    textboxB->setScrollBarVertically(true);
	    
    WidgetButton * knopf;

    knopf = createButton();
    knopf->setBounds(FENSTERBREITE-KNOPFBREITE-10,5,KNOPFBREITE-2,KNOPFHOEHE);
    knopf->setText("Hilfe");
    knopf->onClicked(&FensterFabrik::zeigeHilfe);    

    knopf = createButton();
    knopf->setBounds(10,30,KNOPFBREITE,KNOPFHOEHE);
    knopf->setText("lschen");
    knopf->onClicked(&FensterFabrik::loescheTextboxA);    

    knopf = createButton();
    knopf->setBounds(10+KNOPFBREITE,30,KNOPFBREITE,KNOPFHOEHE);
    knopf->setText("abschicken");
    knopf->onClicked(&FensterFabrik::sendeTextboxA);    

    knopf = createButton();
    knopf->setBounds(10,30+FENSTERHOEHE/2+KNOPFHOEHE+2-40-180,KNOPFBREITE-2,KNOPFHOEHE);
    knopf->setText("lschen");
    knopf->onClicked(&FensterFabrik::loescheTextboxB);    

    knopf = createButton();
    knopf->setBounds(10+KNOPFBREITE,30+FENSTERHOEHE/2+KNOPFHOEHE+2-40-180,KNOPFBREITE-2,KNOPFHOEHE);
    knopf->setText("Zwischenablage");
    knopf->onClicked(&FensterFabrik::kopiereTextboxB);    

    knopf = createButton();
    knopf->setBounds(10+2*KNOPFBREITE,30+FENSTERHOEHE/2+KNOPFHOEHE+2-40-180,KNOPFBREITE-2,KNOPFHOEHE);
    knopf->setText("Grafik");
    knopf->onClicked(&FensterFabrik::erzeugeGrafik);    
        
    puffer = "";
    initRS232();
  }  

  private:
    vector<double> x;
    vector<double> y;
    
        
    COLORREF thecolor;    
                
    string puffer;    
                 
    RS232* rs232;
    WidgetTextBox* textboxA;
    WidgetTextBox* textboxB;
    bool textA;     

   void painting( SmartWin::Canvas & c )
   {
		thecolor = 0x00000000; // Defaulting to yellow...
        
		// Use this color until pen and brush goes out of scope.
		SmartWin::Pen  pen( c, thecolor );
		SmartWin::Brush  brush( c, thecolor );
        
        if(x.size()>0 && x.size()==y.size())
        {
            c.moveTo( (int)GRAFIK_XOFF-2, (int)GRAFIK_YOFF-2 );
            c.lineTo( (int)GRAFIK_XOFF+(int)GRAFIK_BREITE+2, (int)GRAFIK_YOFF-2);
            c.lineTo( (int)GRAFIK_XOFF+(int)GRAFIK_BREITE+2, (int)GRAFIK_YOFF+(int)GRAFIK_HOEHE+2);
            c.lineTo( (int)GRAFIK_XOFF-2, (int)GRAFIK_YOFF+(int)GRAFIK_HOEHE+2);
            c.lineTo( (int)GRAFIK_XOFF-2, (int)GRAFIK_YOFF-2 );
            
            
            c.moveTo( (int)(x.at(0)+0.5), (int)(y.at(0)+0.5) );
            for(int i=1;i<x.size();i++)
		        c.lineTo( (int)(x.at(i)+0.5), (int)(y.at(i)+0.5) );
        }    
		//c.line( x2, y, x4, y + yinc );
		//c.lineTo( 0, y );

   }
            
   void zeigeText(string text)
   {
           createMessageBox().show(text);
   }

  void zeigeHilfe(WidgetButton * btn)
  {
       createMessageBox().show(Datei::lade("hilfe.txt"));
  }

  void loescheTextboxA(WidgetButton * btn)
  {
       textboxA->setText("");
  }

  void sendeTextboxA(WidgetButton * btn)
  {
        //Es sollen Befehle fr den AVR sein.
        //Diese sollen gekennzeichnet durch ein vorangestelltes & und ein beendendes # sein.
        //rs232Thread.suspend();
        rs232->schreibeZeichen('&');
        for(int i=0;i<30000;i++);
        string text = textboxA->getText();
        for(int i=0;i<text.size();i++)
        {
            rs232->schreibeZeichen(text.at(i));
            for(int i=0;i<30000;i++);
        }
        rs232->schreibeZeichen('#');
        for(int i=0;i<30000;i++);
        
        //rs232Thread.resume();
  }

  void loescheTextboxB(WidgetButton * btn)
  {
       textboxB->setText("");
       puffer = "";
  }
  
  void kopiereTextboxB(WidgetButton * btn)
  {
      textboxB->setFocus();
      textboxB->setSelection(0,-1);      
      string text = textboxB->getSelection();
      ClipBoard<string>& clip = ClipBoard<string>::instance();
      clip.setClipBoardData(text,this);   
  }

  void erzeugeGrafik(WidgetButton * btn)
  {
      char zz[2] = {' ','\0'};  
        
      string erg = "Daten:\n";
      stringstream st;
      string hilf;

      string text = textboxB->getText();
      vector<string>* zeilen = Parser::split(text,10);
           
      string zahl1,zahl2;
      char c;
      
      x.clear();
      y.clear();
      
      for(int i=0;i<zeilen->size();i++)
      {
            zahl1="";
            zahl2="";
            string akt = zeilen->at(i);
            int k=0;
            while(k<akt.size())
            {
                c = akt.at(k);
                
                if( Parser::istZahlzeichen(c) )
                     break;                    
                k++;     
            }

            while(k<akt.size())
            {
                c = akt.at(k);
                
                if( !Parser::istZahlzeichen(c) )
                     break;
                zz[0] = c;      
                zahl1.append(zz);
                k++;                         
            }

            while(k<akt.size())
            {
                c = akt.at(k);
                
                if( Parser::istZahlzeichen(c) )
                     break;                    
                k++;     
            }

            while(k<akt.size())
            {
                c = akt.at(k);
                
                if( !Parser::istZahlzeichen(c) )
                     break;
                zz[0] = c;      
                zahl2.append(zz);
                k++;                         
            }
            
            if(zahl1.size()>6 && zahl2.size()>6)
            {
                x.push_back(atof(zahl1.data()));
                y.push_back(atof(zahl2.data()));
            }
      } 
      
      for(int i=0;i<x.size();i++)
      {
          st.clear();
          st<<x.at(i);
          st>>hilf;
          erg.append(hilf);
          erg.append(" ");
          st.clear();
          st<<y.at(i);
          st>>hilf;
          erg.append(hilf);
          erg.append("\n");
      }

//      zeigeText(erg);
      
      //Werte skalieren:
      double xmin,xmax,ymin,ymax; 
      
      xmin = x.at(0); 
      xmax = x.at(0); 
      ymin = y.at(0); 
      ymax = y.at(0); 
       
      for(int i=0;i<x.size();i++)
      {
          if(x.at(i)>xmax) xmax = x.at(i);
          if(x.at(i)<xmin) xmin = x.at(i);
          if(y.at(i)>ymax) ymax = y.at(i);
          if(y.at(i)<ymin) ymin = y.at(i);
      } 

      if(xmin<xmax && ymin<ymax)
      {
        for(int i=0;i<x.size();i++)
        {
            x.at(i) = (x.at(i)-xmin)/(xmax-xmin);
            y.at(i) = (y.at(i)-ymin)/(ymax-ymin);
        } 
      }

        for(int i=0;i<x.size();i++)
        {
            x.at(i) = GRAFIK_BREITE*x.at(i) + GRAFIK_XOFF;
            y.at(i) = GRAFIK_HOEHE*(1.0-y.at(i)) + GRAFIK_YOFF;
        } 
     
      updateWidget();     
  }
  
  void initRS232()
  {
      rs232 = new RS232(115200);
      rs232Thread = fork( tstring(_T("Thread 1")), &FensterFabrik::liesRS232thread );
//      rs232Thread = fork( "rs232", &FensterFabrik::liesRS232thread );
    
  }

	// Thread 1 function
	unsigned long liesRS232thread( tstring & message )
	{
        char zeichen;
        char zeichen_alt;
        static DWORD iBytesRead;
        bool gelesen;
        int wert;
        int anzahl;
        int MAXANZ = 10;
        char z[2] = {' ','\0'};
        char umbruch[3] = {13,10,'\0'};
        anzahl = 0;
		// Loop until closing is true
		zeichen_alt = 0;
		while( !isClosing )
		{
			// Aquire lock
			Utilities::ThreadLock lock(getCriticalSection());

            gelesen = ReadFile(rs232->hCom, &zeichen, 1, &iBytesRead, NULL);
            if( iBytesRead )
            {
                z[0] = zeichen;
                if(zeichen==10 && zeichen_alt!=13)
                    puffer.append(umbruch);
                else if(zeichen!='\r')    
                    puffer.append(z);
                textboxB->setText(puffer);
                zeichen_alt = zeichen;
            }
		}
		return 0;
	}
    
    //Methoden, um ordentlich zu beenden:
        
	bool closeIndeed()
	{
		// Letting the exitApplication thread get to return and free it's resources before closing the application
		Utilities::Thread::waitForObject( exitThread );
		return true;
	}

	unsigned long exitApplication( int & x /* Dummy variable*/ )
	{
		// "Signaling"
		isClosing = true;

		// Starting threads again (in case they are suspended) since we NEED them to run in order to be able to return from them
		rs232Thread.resume();

		// Waiting for threads to end
		std::vector<Utilities::Thread> vecThreads;
		vecThreads.push_back( rs232Thread );
		Utilities::Thread::waitForObjects( vecThreads );

		// Setting close to "guaranteed closing"
		onClosing( &FensterFabrik::closeIndeed );

		// Posting close event (asyncron since we need to return from this function BEFORE handling the close event)
		close( true );
		return 0;
	}

	bool closeApp()
	{
		// Wee need a dummy variable since fork MUST have an argument...
		int x = 0;
		exitThread = fork( x, &FensterFabrik::exitApplication );
		return false;
	}
              
};
