class PWMtimer0
{
    public: 
        PWMtimer0(RS232* rs232)
	    {
		    rs232->sendeText("\n\rInstanz der Klasse *PWMtimer0* gebildet\n\r");
		    rs232->sendeText("\n\r***** PWM Timer 0 *****\n\r");
		    rs232->sendeText("AVR-Konfiguration fuer ATmega32:\n\r");
		    rs232->sendeText("Betroffene Pins: 4 (PB3/OC0/AIN1)\n\r");
		    rs232->sendeText("Betroffene Register: TCCR0\n\r");
		    rs232->sendeText("Bezeichnung: Timer0 auf 8 Bit Phase Correct PWM-Mode mit Taktteilung 1\n\r");
		    rs232->sendeText("Methoden:\n\r");
		    rs232->sendeText("start(): Initialisieren\n\r");
		    rs232->sendeText("stop():  Zurcksetzen\n\r");
		    rs232->sendeText("setzePulsbreitePin4(unsigned char) \n\r");
	    }

		PWMtimer0()
		{
		}


		void setzePulsbreitePin4(unsigned char breite)
		{
		    OCR0 = breite;
		}

        void start()
		{
            TCCR0 = (0<<FOC0) | (1<<WGM00) | (1<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (1<<CS00);
            DDRB |= (1<<PB3); //auf Ausgang setzen.
			//Auf High setzen
			OCR0 = 0;
		}

        void stop()  //alle Register zurcksetzen, Timer und PWM ausschalten.
		{
			OCR0 = 0;
            TCCR0 = (0<<FOC0) | (0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (0<<CS00);

            PORTB &= 255 - (1<<PB3); //sicherheitshalber auf Low setzen (L293 reagiert auf High !)
		}
        
};
