class PWMtimer1
{
    public: 
        PWMtimer1(RS232* rs232)
	    {
		    init();

		    rs232->sendeText("\n\rInstanz der Klasse *PWMtimer1* gebildet\n\r");
		    rs232->sendeText("\n\r***** PWM Timer 1 *****\n\r");
		    rs232->sendeText("AVR-Konfiguration fuer ATmega32:\n\r");
		    rs232->sendeText("Betroffene Pins: 18 (PD4/OC1B) 19 (PD5/OC1A) \n\r");
		    rs232->sendeText("Betroffene Register: TCCR1A TCCR1B\n\r");
		    rs232->sendeText("Bezeichnung: Timer1 auf 8 Bit Phase Correct PWM-Mode mit Taktteilung 1\n\r");
		    rs232->sendeText("Pulsbreite Pin 18 und 19 kann getrennt eingestellt werden.\n\r");
		    rs232->sendeText("Methoden:\n\r");
		    rs232->sendeText("setzePulsbreitePin18(unsigned char) \n\r");
		    rs232->sendeText("setzePulsbreitePin19(unsigned char) \n\r");
	    }

		PWMtimer1()
		{
		    init();
		}

		~PWMtimer1()
		{
	        TCCR1A = 0b00000000;
            TCCR1B = 0b00000000;
            PORTD &= 255 - ((1<<PD4) | (1<<PD5)); //sicherheitshalber auf Low setzen.
		}

		void setzePulsbreitePin18(unsigned char breite)
		{
            OCR1B = breite;
		}

		void setzePulsbreitePin19(unsigned char breite)
		{
            OCR1A = breite;
		}
    private:

        void init()
		{
            //TCC1A
            //Bit:  7       6       5       4	
	        //Bez.: COM1A1, COM1A0, COM1B1, COM1B0
            //legt PWM-Mode fest 

            //Bit:  3       2       
	        //Bez.: FOC1A   FOC1B
            //mssen 0 sein in PWM-Mode

	        //Bit:  1       0
	        //Bez.: WGM11   WGM10
            //fr 8-Bit phasen korrektem PWM:
	        //Bel.: 0       1      

	        TCCR1A = 0b10100001;



	        //Bit:  2       1     0
	        //Bez.: CS12    CS11  CS10
	        //Teilung des Taktes: 001 /1  010 /8 011 /64 100 /256
	        //Bel.: 0       1     1
	   
            //    TCCR1B = 0b00000011;
            TCCR1B = 0b00000001;

            DDRD |= (1<<PD4) | (1<<PD5); //auf Ausgang setzen.

            OCR1B = 0;
            OCR1A = 0;
		}
};
