#define TIMEOUT 30000

class RS232
{
    public:
        RS232()
		{
		    taktfrequenz = 8000000;
			baudrate     = 19200;
			datenbits    = 8;
			stopbits     = 1;
			bootecho     = true;
		    init();
		}
        RS232(unsigned long tf, unsigned long br, bool be)
		{
		    taktfrequenz = tf;
			baudrate     = br;
			datenbits    = 8;
			stopbits     = 1;
			bootecho     = be;
		    init();
		}

        ~RS232()
		{
	        //Ausschalten des Senders und des Empfngers
	        UCSRB &= 255 - (  (1<<TXEN) | (1<<RXEN)  );	
		}

        //Ein Befehl soll so definiert sein, dass er mit einem & beginnt und mit # endet.
		//Ein Befehl darf nicht lnger, als die Kapazitt des Ringpuffers sein.
		//Somit wird solange Zeichen fr Zeichen im Ringpuffer gespeichert, bis ein # erscheint.
		//Danach wird rckwaerts geschaut, wo das nchstliegende & kommt, dann wird der
		//Inhalt zwischen & und # in der Variablen befehl gespeichert.
        char* holeBefehl()
		{
            while(true)
			{
	            while( !(UCSRA & (1<<RXC)) );
				    
				zeichen=UDR;
				if(zeichen=='&')
				    break;
	        }
			i=0;
            while(true)
			{
	            while( !(UCSRA & (1<<RXC)));
				befehl[i]=UDR;
				if(befehl[i]=='#')
				    break;
                i++;
	        }
            befehl[i]='\0';

			return befehl_zeiger;
		}

        bool istGleich(char* a,char* b,int anz, int vona, int vonb)
		{
		    for(kk=0;kk<anz;kk++)
			    if(a[kk+vona]!=b[kk+vonb])
				    return false;
            return true;
		}

        int getZeichenkettenlaenge(char* text)
		{
		    i=0;
			while(text[i]!='\0')
			    i++;
            return i;
		}
        //bergeben wird die Reihe der mglichen Befehle 
		//durch Kommata getrennt.
		//zurckgegeben wird die Nummer des empfangenen Befehls in
		//der befehlsreihe, beginnend mit 0, oder -1, falls der
		//empfangene Befehl nicht in der Liste ist.
        int holeBefehlKomfort(char* befehlssatz)
		{
            sendeText("\n\rSchicken Sie einen der folgenden Befehle:\n\r");
            sendeText(befehlssatz);
            sendeText("\n\r");

            befehl_zeiger = holeBefehl();
//sendeText("Befehl: ");
//sendeText(befehl_zeiger);
//sendeText("\n\r");
            laenge1 = getZeichenkettenlaenge(befehlssatz);
            laenge2 = getZeichenkettenlaenge(befehl_zeiger);

            gefunden = false;

            ii=0;
            while(ii<laenge1-laenge2+1)
            {
                if(istGleich(befehl_zeiger,befehlssatz,laenge2,0,ii))
				{
				    gefunden = true;
					break;
				}
				ii++;
			}

			if(gefunden==false)
			    return -1;

            //Kommata zaehlen (ergeben Position in Befehlssatz)
			p=0;
			for(kk=ii;kk>=0;kk--)
			    if(befehlssatz[kk]==',')
				    p++;

            return p;
		}

		void sendeByte(unsigned char data)
		{
	        UDR = data;
		}
		void sendeZeichen(char zeichen)
		{
	        UDR = zeichen;
		}
		void sendeText(char* text)
        {
		    i=0;
			while(text[i]!='\0')
			{
			    UDR = text[i];
				for(k=0;k<500;k++);
				//if(i%10==0)
				//    for(k=0;k<30000;k++);
				i++;
			}    
		}

        void sendeIntegerZahl(int zahl)
		{
            if(zahl==0)
			{
			    sendeText("     0 ");
				return;
			}

		    if(zahl<0)
			{
		        puffer[0] = '-';
				zahl = -zahl;
            }
			else
			{
		        puffer[0] = ' ';
            }
		    puffer[1] = ' ';
		    puffer[2] = ' ';
		    puffer[3] = ' ';
		    puffer[4] = ' ';
		    puffer[5] = ' ';
		    puffer[6] = '\0';
 
		    i=5;
			while(zahl!=0)
			{
			    puffer[i] = (zahl%10) + 48;
				zahl/=10;
				i--;
			}
			if(i>0)
			{
                puffer[i]=puffer[0];
				puffer[0]=' ';
            }
			sendeText(puffer);
			sendeZeichen(' ');
		}

        void sendeUnsignedIntegerZahl(unsigned int zahl)
		{
            if(zahl==0)
			{
			    sendeText("     0 ");
				return;
			}

		    puffer[0] = ' ';
		    puffer[1] = ' ';
		    puffer[2] = ' ';
		    puffer[3] = ' ';
		    puffer[4] = ' ';
		    puffer[5] = '\0';
 
		    i=4;
			while(zahl!=0)
			{
			    puffer[i] = (zahl%10) + 48;
				zahl/=10;
				i--;
			}
			sendeText(puffer);
			sendeZeichen(' ');
		}


        void sendeDoubleZahl(double zahl) //achtung: Bereich +/-4200 bei 6 Nachkommastellen
		{            
            if(zahl<0.0)
			{
			    k=1;
				zahl = -zahl;
            }
			else
			{
			    k=0;
			}

            if(zahl>4200.0)
			{
			    sendeText("zu gross! ");
				return;
			}
            //-4200.000000
			//012345678901
            puffer[0] = ' ';
            puffer[1] = ' ';
            puffer[2] = ' ';
            puffer[3] = ' ';
            puffer[4] = ' ';
            puffer[5] = ' ';
            puffer[6] = ' ';
            puffer[7] = ' ';
            puffer[8] = ' ';
            puffer[9] = ' ';
            puffer[10] = ' ';
            puffer[11] = ' ';
            puffer[12] = '\0';

            hilf = (unsigned long)(1000000.0*zahl);

		    i=11;
			while(hilf!=0 || i>=4)
			{
			    puffer[i] = (hilf%10) + 48;
				hilf/=10;
				i--;
				if(i==5)
				{
				    puffer[i]='.';
					i--;
				}
			}
            if(k==1)
			    puffer[i] = '-';
			sendeText(puffer);
			sendeText(" ");
		}

	private:
        bool gefunden;
	    int laenge1,laenge2;
	    char leer[1];
        char befehl[200];
		char* befehl_zeiger;
	    char puffer[200];
		char zeichen;
		unsigned long hilf;
	    unsigned int i;
	    unsigned int k;
	    unsigned int p;
		int ii,kk;
	    unsigned long taktfrequenz;
		unsigned long baudrate;
		unsigned char datenbits;
		unsigned char stopbits;
        bool          bootecho;

        unsigned int  baudregister;

        void gibRueckmeldung()
		{
		    sendeText("\n\r***** RS232 ******\n\r");
		    sendeText("AVR-Konfiguration fuer ATmega32:\n\r");
		    sendeText("Betroffene Pins: 14 (PD0/RXD),15 (PD1/TXD)\n\r");
		    sendeText("Betroffene Register: UBRRH, UBRRL, UCSRA, UCSRB, UCSRC\n\r");
		    sendeText("Bezeichnung: USART (RS232)\n\r");
		    sendeText("RS232 zum Senden vorbereiten:\n\r");
			sprintf(puffer,"Taktfrequenz: %lu\n\r",taktfrequenz);
		    sendeText(puffer);
			sprintf(puffer,"Baudrate: %lu\n\r",baudrate);
		    sendeText(puffer);
			sprintf(puffer,"Datenbits: %u\n\r",datenbits);
		    sendeText(puffer);
			sprintf(puffer,"Stopbits: %u\n\r",stopbits);
		    sendeText(puffer);
			sprintf(puffer,"Berechneter Eintrag fuer UBRR-Register: %i\n\r",baudregister);
		    sendeText(puffer);
		}

		void init(void)
		{
            befehl_zeiger = befehl;

            leer[0] = '\0';

            baudregister = taktfrequenz/8/baudrate-1;

	        //setzen der Baudrate
	        UBRRH = (unsigned char) (baudregister>>8); //Setzen des HIGH-Bytes des Baudraten-Registers
	        UBRRL = (unsigned char)  baudregister;     //Setzen des LOW -Bytes des Baudraten-Registers
	
	        //Einschalten des Senders und des Empfngers
	        UCSRB = (1<<TXEN) | (1<<RXEN);
	
	        //Setzen des Nachrichtenformats: 8 Datenbits, 2 Stopbits
	        //UCSRC = (1<<URSEL)|(1<<USBS)|(1<<UCSZ0)|(1<<UCSZ1);
	        //Setzen des Nachrichtenformats: 8 Datenbits, 1 Stopbits
	        UCSRC = (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1);
            UCSRA = (1<<U2X);

			if(bootecho==true)
			{
			    gibRueckmeldung();
			}
		}
};
