#include <avr/io.h>
#include <avr/signal.h>

#include <stdio.h>
#include <stdlib.h>

//#define TAKT 9216000
#define TAKT 3686411
#define BAUD 115200
#define MERKANZ 50

#define VORTEILUNG 1024
#define RADTEILUNG 36
#define MEINPI 3.1415926535897932

//#include "Befehlssatz.h"
#include "RS232.h"


#include "PWMtimer0.h"
//#include "PWMtimer1.h"
#include "PWMtimer2.h"
#include "StopuhrTimer1.h"

#include "Digitalio.h"

volatile unsigned int merker[MERKANZ];
volatile int ii,kk;
volatile double dd;
volatile unsigned long mittelwert;
volatile int merk=0;
bool ZYKLUS = false;

char* textzeiger;

RS232* zeiger_rs232 = 0;
StopuhrTimer1* zeiger_stopuhrtimer1 = 0;
PWMtimer0* zeiger_pwm0 = 0;
PWMtimer2* zeiger_pwm2 = 0;


//Fr Regelung:
volatile double K,TN,TV; 

volatile double upm_soll,wsoll,wist;
volatile double wdiff,wdiff_alt,adiff,sdiff;
volatile double t,dt;
volatile unsigned int zaehlerstand; 
volatile double stellwert;

void pause_millis(unsigned long dauer) //>0 !!!!
{
    dauer *=(TAKT/1000); //in Taktzyklen umrechnen
	dauer -=752;          //Taktzyklen fr die ersten Befehle abziehen
	dauer/=35;           //durch Taktzyklen pro Schleifendurchlauf teilen.
    while(dauer>0) dauer--;    
	return;
}

void berechnePID()
{
       dt = ((double)VORTEILUNG*(double)zaehlerstand)/(double)TAKT;
	   if(zaehlerstand>0)
	       wist = (2.0*MEINPI*(double)TAKT)/((double)RADTEILUNG*(double)VORTEILUNG*(double)zaehlerstand);
       else
	       wist = 0.0;

       wdiff_alt = wdiff;
       wdiff = wsoll - wist;
       
       sdiff += 0.5*(wdiff+wdiff_alt)*dt;
	   if(dt>0.0)
           adiff  = (wdiff-wdiff_alt)/dt;

       stellwert = K*( wdiff + (1.0/TN)*sdiff + TV*adiff );
//stellwert = K*wdiff;
//stellwert = 200.0;


//zeiger_rs232->sendeText("s=");
//zeiger_rs232->sendeDoubleZahl(wdiff);
//zeiger_rs232->sendeText("\n\r");


       if(stellwert>=0.0)
	   {
	           PORTC = 0b00000010;
	   }
	   else
	   {
	           stellwert = -stellwert;
	           PORTC = 0b00000001;
	   }

       if(stellwert>255.0)
	   {
//           zeiger_rs232->sendeText("\n\rStellwert zu gross! \n\r");
		   stellwert = 255.0;
	   }
	   t+=dt;
}

SIGNAL(SIG_INPUT_CAPTURE1)
{
 	zeiger_stopuhrtimer1->resetZaehler();
	zaehlerstand = zeiger_stopuhrtimer1->getZaehlstand();				   
	if( zeiger_stopuhrtimer1->pruefeUeberlauf() )
    {
	    zeiger_rs232->sendeText("\n\rUeberlauf! \n\r");
    }
    else if(merk<MERKANZ && zaehlerstand>10)
	{
       merker[merk] = zaehlerstand;
	   merk++;

       berechnePID();
       zeiger_pwm0->setzePulsbreitePin4((int)stellwert);
       zeiger_pwm2->setzePulsbreitePin21((int)stellwert);
    }
}


void anfahren(PWMtimer0* pwm0,PWMtimer2* pwm2,StopuhrTimer1* stopuhr,RS232* zeiger_rs232)
{

	zeiger_rs232->sendeText("PID-Regler: u(t) = K*( wsoll-wist +(1/TN)*INTEG(wsoll-wist) +TV*DER(wsoll-wist) )\n\r");

	zeiger_rs232->sendeText("Geben sie K ein:\n\r");
	textzeiger = zeiger_rs232->holeBefehl(); 
	K = atof(textzeiger);
	zeiger_rs232->sendeText("K=");
	zeiger_rs232->sendeText(textzeiger);
	zeiger_rs232->sendeText("\n\r");

	zeiger_rs232->sendeText("Geben sie TN ein:\n\r");
	textzeiger = zeiger_rs232->holeBefehl(); 
	TN = atof(textzeiger);
	zeiger_rs232->sendeText("TN=");
	zeiger_rs232->sendeText(textzeiger);
	zeiger_rs232->sendeText("\n\r");

	zeiger_rs232->sendeText("Geben sie TV ein:\n\r");
	textzeiger = zeiger_rs232->holeBefehl(); 
	TV = atof(textzeiger);
	zeiger_rs232->sendeText("TV=");
	zeiger_rs232->sendeText(textzeiger);
	zeiger_rs232->sendeText("\n\r");

	zeiger_rs232->sendeText("Geben sie die Solldrehzahl in U/Min ein (500..1500):\n\r");
	textzeiger = zeiger_rs232->holeBefehl(); 
	upm_soll = atof(textzeiger);
	zeiger_rs232->sendeText("upm_soll=");
	zeiger_rs232->sendeText(textzeiger);
	zeiger_rs232->sendeText("\n\r");


    //Soll Winkelgeschwindigkeit bestimmen:
	wsoll = (2.0*MEINPI*upm_soll)/60.0;

    wdiff=0.0;
	adiff=0.0;
	sdiff=0.0;
	t=0.0;
    dt=0.0;

    pwm0->start();
    pwm2->start();

    merk = 0;
    zaehlerstand = 0;
	berechnePID();

	zeiger_rs232->sendeText("Startwert fr Stellsignal (+-255): ");
	zeiger_rs232->sendeDoubleZahl(stellwert);
	zeiger_rs232->sendeText("\n\r");



    stopuhr->start();

    zeiger_pwm0->setzePulsbreitePin4((int)stellwert);
    zeiger_pwm2->setzePulsbreitePin21((int)stellwert);



	pause_millis(9000);

    stopuhr->pruefeUeberlauf();
	stopuhr->resetZaehler();

	pause_millis(3000);

    stopuhr->stop();

    pwm0->stop();
    pwm2->stop();


    zeiger_rs232->sendeText("Auswertung vom Anfahren:\n\r");
//    zeiger_rs232->sendeText("Zeit/s    Zhlpulse\n\r");
//    zeiger_rs232->sendeText("Zeit/s    Geschwindigkeit/ms-1\n\r");
//    zeiger_rs232->sendeText("Zeit/s    Winkelgeschwindigkeit/rads-1\n\r");
    zeiger_rs232->sendeText("Zeit/s    Umdrehungen/Min.\n\r");
	dd = 0.0;
    for(ii=2;ii<merk;ii++)
	{
        zeiger_rs232->sendeDoubleZahl(dd);	    
        zeiger_rs232->sendeText(" ");	    
//        zeiger_rs232->sendeDoubleZahl(  merker[ii]  );	    
//        zeiger_rs232->sendeDoubleZahl(  stopuhr->berechneGeschwindigkeit(merker[ii])  );	    
//        zeiger_rs232->sendeDoubleZahl(  stopuhr->berechneWinkelgeschw(merker[ii])  );	    
        zeiger_rs232->sendeDoubleZahl(  stopuhr->berechneUPM(merker[ii])  );	    
        zeiger_rs232->sendeText("\n\r");	    
		dd+=stopuhr->berechneDauerSek(merker[ii]);
	}

    return;
}

int main()
{
    int befehlnummer;

    DDRC = 0b00000011;

    PORTC = 0b00000010;

    setzePinAlsAusgang(4);
    setzePinAlsAusgang(21);

    setzePinLow(4);
    setzePinLow(21);

    RS232 rs232(TAKT,BAUD,true);

    zeiger_rs232 = &rs232;
    PWMtimer0 pwm0(zeiger_rs232);
    PWMtimer2 pwm2(zeiger_rs232);

    zeiger_pwm0 = &pwm0;
    zeiger_pwm2 = &pwm2;


//    StopuhrTimer1 stopuhr(zeiger_rs232,1024);
    StopuhrTimer1 stopuhr(zeiger_rs232,VORTEILUNG,RADTEILUNG);

    while(true)
	{
	
		befehlnummer = rs232.holeBefehlKomfort("anfahren, nichts1, nichts2");
        switch(befehlnummer)
		{
		    case 0:
			    rs232.sendeText("Sie haben den Befehl *anfahren* gewhlt.\n\r");
				anfahren(&pwm0,&pwm2,&stopuhr,zeiger_rs232);
			break;
			case 1:
			    rs232.sendeText("Sie haben den Befehl *rueck* gewhlt.\n\r");
			break;
			case 2:
			    rs232.sendeText("Sie haben den Befehl *dreh* gewhlt.\n\r");
			break;
			default:
			    rs232.sendeText("Sie haben einen ungltigen Befehl gewhlt.\n\r");
			break;
		}
	}
}
